!
!  Sky - average sky value
!     Copyright (C) 1999  Filip Hroch, Masaryk University, Brno, CZ
!
!
! 1999, september ..  to F90, + other many changes
!
!
!===========================================================================
!

subroutine  sky (ncol, nrow, d, nmax, hibad, skymn, skymed, skymod, n)

!
!=======================================================================
!
! This subroutine estimates an average sky value for a picture by taking
! individual pixels scattered over the picture.  The brightness values
! are sorted, and the modal value is estimated using the MMM subroutine.
!
!               OFFICIAL DAO VERSION:  1991 April 18
!
!=======================================================================
!
      implicit none
      integer :: nmax
!
! MAX    is the maximum number of sky pixels we can deal with,
!        given the limited amount of working space.
!

      integer :: ncol, nrow, n, i, j
      real :: d(ncol,nrow), s(nmax) 
!
      real :: hibad, skymn, skymed, skymod, skysig, skyskw
      integer :: istep 
!
!-----------------------------------------------------------------------
!
! The spacing between pixels that will be included in the sample is
! estimated by the ratio of the total number of pixels in the picture to
! the maximum number of pixels that can be accomodated in the vector S.
!
      istep = max((ncol*nrow)/nmax, 1)
!
! Go through the disk file reading a row at a time and extracting every
! ISTEP-th pixel.  If ISTEP is not equal to 1, make sure that the
! starting pixel for each row is staggered.
!

!     don't work under SGI:     
!     s = pack( d(1:ncol:istep,1:nrow:istep), abs(d) <= hibad)
!     n = (ncol*nrow)/istep**2
      n = 0
      do i = 1, ncol, istep
         do j = 1, nrow, istep
            if( abs(d(i,j)) <= hibad ) then
               n = n + 1
               s(n) = d(i,j)
            endif
         enddo
      enddo

!
! Sort these values, then estimate the mode.
!

      call robustmean1(s, n, skymn, skymed, skymod, skysig, skyskw)

      write (*,"(A,F9.1,A,F10.2)")                      &
        ' Approximate sky value for this frame =', skymod,' +- ',skysig     
 
      end







